require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.content.Context"
import "android.os.Vibrator"
import "android.content.Intent"
import "android.net.Uri"
import "android.view.KeyEvent"

-- Mensaje de bienvenida limpio
local bienvenidaMensaje = [[
Bienvenidos a la comunidad de por un mundo más accesible.
"Por un mundo más accesible" es nuestro lema. En este espacio encontrarás contenido accesible y divertido para tu día a día, con el objetivo de inspirar e impulsar un entorno más inclusivo para todos.
Únete a nuestra comunidad y sé parte del cambio hacia un mundo más accesible para todos.
]]

-- Enlaces oficiales
local enlaces = {
  YouTube = "https://youtube.com/@porunmundomasaccesible?si=3b0umrdJr73StrGj",
  GrupoTelegram = "https://t.me/mundoaccesible",
  CanalTelegram = "https://t.me/porun_mundo_mas_accesivle",
}

-- Contexto y vibrador
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)

-- Vibración inicial
vibrator.vibrate(100)

-- Layout principal
layout = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "match_parent",
  layout_height = "match_parent",
  {
    TextView,
    text = bienvenidaMensaje,
    textSize = "18sp",
    gravity = "center",
    padding = "16dp",
    layout_width = "match_parent",
    layout_height = "wrap_content",
  },
  {
    Button,
    text = "Canal de YouTube",
    onClick = function(view)
      openLink(enlaces.YouTube)
    end,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_margin = "8dp",
  },
  {
    Button,
    text = "Grupo de Telegram",
    onClick = function(view)
      openLink(enlaces.GrupoTelegram)
    end,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_margin = "8dp",
  },
  {
    Button,
    text = "Canal de Telegram",
    onClick = function(view)
      openLink(enlaces.CanalTelegram)
    end,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_margin = "8dp",
  },
  {
    Button,
    text = "Cerrar",
    onClick = function(view)
      dlg.dismiss()
      vibrator.vibrate(100)
    end,
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_gravity = "end",
    layout_margin = "8dp",
  },
}

-- Crear diálogo
dlg = LuaDialog(service)
dlg.View = loadlayout(layout)

-- Función para abrir un enlace
function openLink(url)
  if not url then
    service.asyncSpeak("El enlace no está disponible.")
    return
  end
  dlg.dismiss()
  local intent = Intent(Intent.ACTION_VIEW)
  intent.setData(Uri.parse(url))
  context.startActivity(intent)
  service.asyncSpeak("El enlace se ha abierto.")
end

-- Mostrar el diálogo
dlg.show()

-- Capturar evento de tecla "Back" para cerrar el diálogo
function onKeyDown(code, event)
  if code == KeyEvent.KEYCODE_BACK then
    dlg.dismiss()
    return true
  end
end